#include "tester.h"
#include "ui_tester.h"

Tester::Tester(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::Tester)
{
    ui->setupUi(this);

    loginWidget = new LoginWidget();
    testSelectionWidget = new TestSelection();

    connect(loginWidget, &LoginWidget::onClosed, this, &Tester::receiveNameAndPassword);
    connect(loginWidget, &LoginWidget::onClosed, testSelectionWidget, &TestSelection::_sh);
    connect(testSelectionWidget, &TestSelection::onClosed, this, &Tester::receiveTestEntity);
    connect(this->ui->pushButton, &QPushButton::clicked, this, &Tester::startExecution);

    this->show();
    loginWidget->show();
}

Tester::~Tester()
{
    delete ui;
}

void Tester::receiveNameAndPassword()
{
    this->currentName = loginWidget->getName();
    this->currentPassword = loginWidget->getPassword();
}

void Tester::receiveTestEntity()
{
    this->currentTest = this->testSelectionWidget->getTestEntity();

    questCount = currentTest->getQuestions().size();

    emit(onDataReceived());
}

void Tester::startExecution()
{
    if(counter < questCount) {
        QVector<QuestionEntity> questVector = currentTest->getQuestions();
        QuestionEntity currentQuestion = questVector[counter];
        drawCurrentQuestion(currentQuestion);
    }
    else{
        ui->textBrowser->setText("Тест закончен, спасибо за участие!");
    }
}

void Tester::drawCurrentQuestion(const QuestionEntity &currentQuestion)
{
    QString testString;

    testString += currentQuestion.getQuestion() + "\n";
    for(auto& var: currentQuestion.getVariants()) {
        testString += "  " + var + "\n";
    }

    this->ui->textBrowser->setText(testString);
    counter++;
}
